#include <windows.h>
#include <dos.h>
#include <direct.h>
#include <stdio.h>
#include <fstream.h>

char szFileName [1024];
char FileFilter [] = {'Q','u','a','k','e',' ','*','.','p','a','k',' ','f','i','l','e','s',0,'*','.','p','a','k',0,0};
DWORD InfoPos = 0;
DWORD InfoFields = 0;
#define CACHESIZE 256

char * lpBuffer = NULL;

typedef struct tagBLOCKINFO
{
  char szName [56];
  DWORD pos;
  DWORD len;
} BLOCKINFO;

BOOL LoadPackParams()
{
  DWORD len;
  fstream fs (szFileName, ios::in | ios::binary);
  fs.read((char *)&InfoFields,4);
  fs.read((char *)&InfoPos,4);
  fs.read((char *)&InfoFields,4);
  InfoFields = InfoFields/sizeof(BLOCKINFO);
  if (fs.fail())
    return FALSE;
  fs.close();
  return TRUE;
}

BOOL CreateDirs(char * srcbuf)
{
  int start,finish,i;
  static char buf [1024];
  start=0;
  do {
    finish=start;
    while ((srcbuf[finish] != '\0')
        && (srcbuf[finish] != '\\'))
    {
      buf[finish] = srcbuf[finish];
      finish++;
    }
    buf[finish]='\0';
    start=finish;
    if (srcbuf[start] != '\0')
    {
      mkdir(buf);
      buf[start] = srcbuf[start];
      start++;
    }
  } while(srcbuf[start] != '\0');
  return TRUE;
}

BOOL Unpack()
{
  BLOCKINFO * Info;
  Info = new BLOCKINFO [CACHESIZE];
  int i,ii,n,j;

  if (Info == NULL)
    return FALSE;
  fstream srcfs (szFileName, ios::in | ios::binary);
  for (i=0; i<InfoFields; )
  {
    n = CACHESIZE;
    if (i + n > InfoFields)
      n = InfoFields - i;
    srcfs.seekg(InfoPos+i*sizeof(BLOCKINFO),ios::beg);
    srcfs.read((char *)&Info[0],n*sizeof(BLOCKINFO));
    for (ii=0; ii<n; ii++)
    {
      for (j=0; Info[ii].szName[j] != 0; j++)
        if (Info[ii].szName[j] == '/')
          Info[ii].szName[j] = '\\';
      CreateDirs(Info[ii].szName);
      lpBuffer = new char [Info[ii].len];
      fstream fs (Info[ii].szName,ios::out | ios::binary);
      srcfs.seekg(Info[ii].pos,ios::beg);
      srcfs.read(lpBuffer,Info[ii].len);
      if (srcfs.fail()) return FALSE;
      fs.write(lpBuffer,Info[ii].len);
      if (fs.fail()) return FALSE;
      fs.close();
      delete [] lpBuffer;
    }
    i += n;
  }
  srcfs.close();
  return TRUE;
}

void main (
  int argn,
  char * argv [] )
{
  static OPENFILENAME ofn;
  memset(&ofn,0,sizeof(ofn));
  ofn.lStructSize = sizeof(ofn);
  ofn.lpstrFile = szFileName;
  ofn.nMaxFile = sizeof(szFileName);
  ofn.lpstrFilter = FileFilter;
  if (argn < 1)
  {
    if (!GetOpenFileName(&ofn))
      return;
  }
  else
  {  strcpy(szFileName,argv[1]);
  }
  if (!LoadPackParams())
  {
    MessageBox(NULL,"Read error","Error",MB_OK);
    return;
  }
  if (!Unpack())
  {
    MessageBox(NULL,"Unpack error","Error",MB_OK);
    return;
  }
  MessageBox(NULL,szFileName,"Done",MB_OK);
}